// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZLibMsSql.pas' rev: 5.00

#ifndef ZLibMsSqlHPP
#define ZLibMsSqlHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ZSqlTypes.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zlibmssql
{
//-- type declarations -------------------------------------------------------
typedef void *PDBPROCESS;

typedef void *PLOGINREC;

typedef void *PDBCURSOR;

typedef void *PDBHANDLE;

typedef int RETCODE;

typedef int STATUS;

typedef char DBCHAR;

typedef Byte DBBINARY;

typedef Byte DBTINYINT;

typedef short DBSMALLINT;

typedef Word DBUSMALLINT;

typedef int DBINT;

typedef double DBFLT8;

typedef Byte DBBIT;

typedef Byte DBBOOL;

typedef float DBFLT4;

typedef int DBMONEY4;

typedef float DBREAL;

typedef unsigned DBUBOOL;

#pragma pack(push, 1)
struct DBDATETIM4
{
	Word numdays;
	Word nummins;
} ;
#pragma pack(pop)

typedef DBDATETIM4 *PDBDATETIM4;

#pragma pack(push, 1)
struct DBVARYCHAR
{
	short Len;
	char Str[256];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct DBVARYBIN
{
	short Len;
	Byte Bytes[256];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct DBMONEY
{
	int mnyhigh;
	unsigned mnylow;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct DBDATETIME
{
	int dtdays;
	unsigned dttime;
} ;
#pragma pack(pop)

typedef DBDATETIME *PDBDATETIME;

#pragma pack(push, 1)
struct DBDATEREC
{
	int year;
	int quarter;
	int month;
	int dayofyear;
	int day;
	int week;
	int weekday;
	int hour;
	int minute;
	int second;
	int millisecond;
} ;
#pragma pack(pop)

typedef DBDATEREC *PDBDATEREC;

#pragma pack(push, 1)
struct DBNUMERIC
{
	Byte Precision;
	Byte Scale;
	Byte Sign;
	Byte Val[16];
} ;
#pragma pack(pop)

typedef DBNUMERIC  DBDECIMAL;

#pragma pack(push, 1)
struct DBCOL
{
	int SizeOfStruct;
	char Name[31];
	char ActualName[31];
	char TableName[31];
	short Typ;
	int UserType;
	int MaxLength;
	Byte Precision;
	Byte Scale;
	BOOL VarLength;
	Byte Null;
	Byte CaseSensitive;
	Byte Updatable;
	BOOL Identity;
} ;
#pragma pack(pop)

typedef DBCOL *PDBCOL;

#pragma pack(push, 1)
struct DBPROC_INFO
{
	int SizeOfStruct;
	Byte ServerType;
	Word ServerMajor;
	Word ServerMinor;
	Word ServerRevision;
	char ServerName[31];
	char NetLibName[256];
	char NetLibConnStr[256];
} ;
#pragma pack(pop)

typedef DBPROC_INFO *PDBPROCINFO;

#pragma pack(push, 1)
struct DBCURSOR_INFO
{
	int SizeOfStruct;
	unsigned TotCols;
	unsigned TotRows;
	unsigned CurRow;
	unsigned TotRowsFetched;
	unsigned CurType;
	unsigned Status;
} ;
#pragma pack(pop)

typedef DBCURSOR_INFO *PDBCURSORINFO;

typedef int *PDBINT;

typedef Byte *PDBBINARY;

typedef int __cdecl (*DBERRHANDLE_PROC)(void * Proc, int Severity, int DbErr, int OsErr, char * DbErrStr
	, char * OsErrStr);

typedef int __cdecl (*DBMSGHANDLE_PROC)(void * Proc, int MsgNo, int MsgState, int Severity, char * MsgText
	, char * SrvName, char * ProcName, Word Line);

typedef DBERRHANDLE_PROC __cdecl (*Tdberrhandle)(DBERRHANDLE_PROC Handler);

typedef DBMSGHANDLE_PROC __cdecl (*Tdbmsghandle)(DBMSGHANDLE_PROC Handler);

typedef DBERRHANDLE_PROC __cdecl (*Tdbprocerrhandle)(void * DbHandle, DBERRHANDLE_PROC Handler);

typedef DBMSGHANDLE_PROC __cdecl (*Tdbprocmsghandle)(void * DbHandle, DBMSGHANDLE_PROC Handler);

typedef int __cdecl (*Tabort_xact)(void * Proc, int CommId);

typedef void __cdecl (*Tbuild_xact_string)(char * XActName, char * Service, int CommId, char * Result
	);

typedef void __cdecl (*Tclose_commit)(void * Proc);

typedef int __cdecl (*Tcommit_xact)(void * Proc, int CommId);

typedef void * __cdecl (*Topen_commit)(void * Login, char * ServerName);

typedef int __cdecl (*Tremove_xact)(void * Proc, int CommId, int SiteCount);

typedef int __cdecl (*Tscan_xact)(void * Proc, int CommId);

typedef int __cdecl (*Tstart_xact)(void * Proc, char * AppName, char * XActName, int SiteCount);

typedef int __cdecl (*Tstat_xact)(void * Proc, int CommId);

typedef int __cdecl (*Tbcp_batch)(void * Proc);

typedef int __cdecl (*Tbcp_bind)(void * Proc, Windows::PByte VarAddr, int PrefixLen, int VarLen, Windows::PByte 
	Terminator, int TermLen, int Typ, int TableColumn);

typedef int __cdecl (*Tbcp_colfmt)(void * Proc, int FileColumn, Byte FileType, int FilePrefixLen, int 
	FileColLen, Windows::PByte FileTerm, int FileTermLen, int TableColumn);

typedef int __cdecl (*Tbcp_collen)(void * Proc, int VarLen, int TableColumn);

typedef int __cdecl (*Tbcp_colptr)(void * Proc, Windows::PByte ColPtr, int TableColumn);

typedef int __cdecl (*Tbcp_columns)(void * Proc, int FileColCount);

typedef int __cdecl (*Tbcp_control)(void * Proc, int Field, int Value);

typedef int __cdecl (*Tbcp_done)(void * Proc);

typedef int __cdecl (*Tbcp_exec)(void * Proc, PDBINT RowsCopied);

typedef int __cdecl (*Tbcp_init)(void * Proc, char * TableName, char * hFile, char * ErrFile, int Direction
	);

typedef int __cdecl (*Tbcp_moretext)(void * Proc, int Size, Windows::PByte Text);

typedef int __cdecl (*Tbcp_readfmt)(void * Proc, char * FileName);

typedef int __cdecl (*Tbcp_sendrow)(void * Proc);

typedef int __cdecl (*Tbcp_setl)(void * Login, BOOL Enable);

typedef int __cdecl (*Tbcp_writefmt)(void * Proc, char * FileName);

typedef Windows::PByte __cdecl (*Tdbadata)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbadlen)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbaltbind)(void * Proc, int ComputeId, int Column, int VarType, int VarLen, Windows::PByte 
	VarAddr);

typedef int __cdecl (*Tdbaltcolid)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbaltlen)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbaltop)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbalttype)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbaltutype)(void * Proc, int ComputeId, int Column);

typedef int __cdecl (*Tdbanullbind)(void * Proc, int ComputeId, int Column, PDBINT Indicator);

typedef int __cdecl (*Tdbbind)(void * Proc, int Column, int VarType, int VarLen, Windows::PByte VarAddr
	);

typedef Windows::PByte __cdecl (*Tdbbylist)(void * Proc, int ComputeId, Windows::PInteger Size);

typedef int __cdecl (*Tdbcancel)(void * Proc);

typedef int __cdecl (*Tdbcanquery)(void * Proc);

typedef char * __cdecl (*Tdbchange)(void * Proc);

typedef int __cdecl (*Tdbclose)(void * Proc);

typedef void __cdecl (*Tdbclrbuf)(void * Proc, int N);

typedef int __cdecl (*Tdbclropt)(void * Proc, int Option, char * Param);

typedef int __cdecl (*Tdbcmd)(void * Proc, char * Cmd);

typedef int __cdecl (*Tdbcmdrow)(void * Proc);

typedef BOOL __cdecl (*Tdbcolbrowse)(void * Proc, int Column);

typedef int __cdecl (*Tdbcolinfo)(void * Handle, int Typ, int Column, int ComputeId, PDBCOL DbColumn
	);

typedef int __cdecl (*Tdbcollen)(void * Proc, int Column);

typedef char * __cdecl (*Tdbcolname)(void * Proc, int Column);

typedef char * __cdecl (*Tdbcolsource)(void * Proc, int Column);

typedef int __cdecl (*Tdbcoltype)(void * Proc, int Column);

typedef int __cdecl (*Tdbcolutype)(void * Proc, int Column);

typedef int __cdecl (*Tdbconvert)(void * Proc, int SrcType, Windows::PByte Src, int SrcLen, int DestType
	, Windows::PByte Dest, int DestLen);

typedef int __cdecl (*Tdbcount)(void * Proc);

typedef int __cdecl (*Tdbcurcmd)(void * Proc);

typedef int __cdecl (*Tdbcurrow)(void * Proc);

typedef int __cdecl (*Tdbcursor)(void * hCursor, int OpType, int Row, char * Table, char * Values);

typedef int __cdecl (*Tdbcursorbind)(void * hCursor, int Col, int VarType, int VarLen, PDBINT POutLen
	, Windows::PByte VarAddr);

typedef int __cdecl (*Tdbcursorclose)(void * DbHandle);

typedef int __cdecl (*Tdbcursorcolinfo)(void * hCursor, int Column, char * ColName, Windows::PInteger 
	ColType, PDBINT ColLen, Windows::PInteger UserType);

typedef int __cdecl (*Tdbcursorfetch)(void * hCursor, int FetchType, int RowNum);

typedef int __cdecl (*Tdbcursorfetchex)(void * hCursor, int FetchType, int RowNum, int nFetchRows, int 
	Reserved);

typedef int __cdecl (*Tdbcursorinfo)(void * hCursor, Windows::PInteger nCols, PDBINT nRows);

typedef int __cdecl (*Tdbcursorinfoex)(void * hCursor, PDBCURSORINFO DbCursorInfo);

typedef void * __cdecl (*Tdbcursoropen)(void * Proc, char * Sql, int ScrollOpt, int ConCurOpt, unsigned 
	nRows, PDBINT PStatus);

typedef Windows::PByte __cdecl (*Tdbdata)(void * Proc, int Column);

typedef BOOL __cdecl (*Tdbdataready)(void * Proc);

typedef int __cdecl (*Tdbdatecrack)(void * Proc, PDBDATEREC DateInfo, PDBDATETIME DateType);

typedef int __cdecl (*Tdbdatlen)(void * Proc, int Column);

typedef BOOL __cdecl (*Tdbdead)(void * Proc);

typedef void __cdecl (*Tdbexit)(void);

typedef int __cdecl (*Tdbfirstrow)(void * Proc);

typedef void __cdecl (*Tdbfreebuf)(void * Proc);

typedef void __cdecl (*Tdbfreelogin)(void * Login);

typedef void __cdecl (*Tdbfreequal)(char * Ptr);

typedef char * __cdecl (*Tdbgetchar)(void * Proc, int N);

typedef short __cdecl (*Tdbgetmaxprocs)(void);

typedef int __cdecl (*Tdbgetoff)(void * Proc, Word OffType, int StartFrom);

typedef unsigned __cdecl (*Tdbgetpacket)(void * Proc);

typedef int __cdecl (*Tdbgetrow)(void * Proc, int Row);

typedef int __cdecl (*Tdbgettime)(void);

typedef void * __cdecl (*Tdbgetuserdata)(void * Proc);

typedef BOOL __cdecl (*Tdbhasretstat)(void * Proc);

typedef char * __cdecl (*Tdbinit)(void);

typedef BOOL __cdecl (*Tdbisavail)(void * Proc);

typedef BOOL __cdecl (*Tdbiscount)(void * Proc);

typedef BOOL __cdecl (*Tdbisopt)(void * Proc, int Option, char * Param);

typedef int __cdecl (*Tdblastrow)(void * Proc);

typedef void * __cdecl (*Tdblogin)(void);

typedef int __cdecl (*Tdbmorecmds)(void * Proc);

typedef int __cdecl (*Tdbmoretext)(void * Proc, int Size, Windows::PByte Text);

typedef char * __cdecl (*Tdbname)(void * Proc);

typedef int __cdecl (*Tdbnextrow)(void * Proc);

typedef int __cdecl (*Tdbnullbind)(void * Proc, int Column, PDBINT Indicator);

typedef int __cdecl (*Tdbnumalts)(void * Proc, int ComputeId);

typedef int __cdecl (*Tdbnumcols)(void * Proc);

typedef int __cdecl (*Tdbnumcompute)(void * Proc);

typedef int __cdecl (*Tdbnumorders)(void * Proc);

typedef int __cdecl (*Tdbnumrets)(void * Proc);

typedef void * __cdecl (*Tdbopen)(void * Login, char * Host);

typedef int __cdecl (*Tdbordercol)(void * Proc, int Order);

typedef int __cdecl (*Tdbprocinfo)(void * Proc, PDBPROCINFO DbProcInfo);

typedef void __cdecl (*Tdbprhead)(void * Proc);

typedef int __cdecl (*Tdbprrow)(void * Proc);

typedef char * __cdecl (*Tdbprtype)(int Token);

typedef char * __cdecl (*Tdbqual)(void * Proc, int TabNum, char * TabName);

typedef int __cdecl (*Tdbreadtext)(void * Proc, void * Buf, int BufSize);

typedef int __cdecl (*Tdbresults)(void * Proc);

typedef Windows::PByte __cdecl (*Tdbretdata)(void * Proc, int RetNum);

typedef int __cdecl (*Tdbretlen)(void * Proc, int RetNum);

typedef char * __cdecl (*Tdbretname)(void * Proc, int RetNum);

typedef int __cdecl (*Tdbretstatus)(void * Proc);

typedef int __cdecl (*Tdbrettype)(void * Proc, int RetNum);

typedef int __cdecl (*Tdbrows)(void * Proc);

typedef int __cdecl (*Tdbrowtype)(void * Proc);

typedef int __cdecl (*Tdbrpcinit)(void * Proc, char * ProcName, short Options);

typedef int __cdecl (*Tdbrpcparam)(void * Proc, char * ParamName, Byte Status, int Typ, int MaxLen, 
	int DataLen, Windows::PByte Value);

typedef int __cdecl (*Tdbrpcsend)(void * Proc);

typedef int __cdecl (*Tdbrpcexec)(void * Proc);

typedef void __cdecl (*Tdbrpwclr)(void * Login);

typedef int __cdecl (*Tdbserverenum)(Word SearchMode, char * ServNameBuf, Word ServNameBufSize, PWORD 
	NumEntries);

typedef void __cdecl (*Tdbsetavail)(void * Proc);

typedef int __cdecl (*Tdbsetmaxprocs)(short MaxProcs);

typedef int __cdecl (*Tdbsetlname)(void * Login, char * Value, int Item);

typedef int __cdecl (*Tdbsetlogintime)(int Seconds);

typedef int __cdecl (*Tdbsetlpacket)(void * Login, Word PacketSize);

typedef int __cdecl (*Tdbsetnull)(void * Proc, int BindType, int BindLen, Windows::PByte BindVal);

typedef int __cdecl (*Tdbsetopt)(void * Proc, int Option, char * Param);

typedef int __cdecl (*Tdbsettime)(int Seconds);

typedef void __cdecl (*Tdbsetuserdata)(void * Proc, void * Ptr);

typedef int __cdecl (*Tdbsqlexec)(void * Proc);

typedef int __cdecl (*Tdbsqlok)(void * Proc);

typedef int __cdecl (*Tdbsqlsend)(void * Proc);

typedef int __cdecl (*Tdbstrcpy)(void * Proc, int Start, int NumBytes, char * Dest);

typedef int __cdecl (*Tdbstrlen)(void * Proc);

typedef BOOL __cdecl (*Tdbtabbrowse)(void * Proc, int TabNum);

typedef int __cdecl (*Tdbtabcount)(void * Proc);

typedef char * __cdecl (*Tdbtabname)(void * Proc, int Table);

typedef char * __cdecl (*Tdbtabsource)(void * Proc, int Column, Windows::PInteger TabNum);

typedef int __cdecl (*Tdbtsnewlen)(void * Proc);

typedef PDBBINARY __cdecl (*Tdbtsnewval)(void * Proc);

typedef int __cdecl (*Tdbtsput)(void * Proc, PDBBINARY NewTs, int NewTsName, int TabNum, char * TableName
	);

typedef PDBBINARY __cdecl (*Tdbtxptr)(void * Proc, int Column);

typedef PDBBINARY __cdecl (*Tdbtxtimestamp)(void * Proc, int Column);

typedef PDBBINARY __cdecl (*Tdbtxtsnewval)(void * Proc);

typedef int __cdecl (*Tdbtxtsput)(void * Proc, PDBBINARY NewTxts, int Column);

typedef int __cdecl (*Tdbuse)(void * Proc, char * DbName);

typedef BOOL __cdecl (*Tdbvarylen)(void * Proc, int Column);

typedef BOOL __cdecl (*Tdbwillconvert)(int SrcType, int DestType);

typedef int __cdecl (*Tdbwritetext)(void * Proc, char * ObjName, PDBBINARY TextPtr, Byte TextPtrLen, 
	PDBBINARY Timestamp, BOOL Log, int Size, Windows::PByte Text);

typedef int __cdecl (*Tdbupdatetext)(void * Proc, char * DestObject, PDBBINARY DestTextPtr, PDBBINARY 
	DestTimestamp, int UpdateType, int InsertOffset, int DeleteLength, char * SrcObject, int SrcSize, PDBBINARY 
	SrcText);

//-- var, const, procedure ---------------------------------------------------
static const Word LIST_BLOCK_SIZE = 0x1f4;
static const Shortint MIN_FETCH_ROWS = 0x0;
static const Shortint MAX_NAME_LENGTH = 0x32;
static const Shortint MAX_LINKS_COUNT = 0x5;
static const Shortint MAX_SORT_COUNT = 0x5;
static const Byte MAX_FIELD_COUNT = 0xff;
static const Shortint MAX_INDEX_COUNT = 0x19;
static const Shortint MAX_INDEX_FIELDS = 0x19;
static const Shortint DEFAULT_STRING_SIZE = 0x32;
static const Word MAX_STRING_SIZE = 0x200;
static const char DEFAULT_MACRO_CHAR = '\x25';
#define ZEOS_PALETTE "Zeos Common"
#define ZEOS_DB_PALETTE "Zeos Access"
static const Word ZDBO_VERSION = 0xc47c;
#define DEFAULT_DLL_LOCATION "ntwdblib.dll"
static const unsigned TIMEOUT_IGNORE = 0xffffffff;
static const Shortint TIMEOUT_INFINITE = 0x0;
static const Word TIMEOUT_MAXIMUM = 0x4b0;
static const Shortint SERVTYPE_UNKNOWN = 0x0;
static const Shortint SERVTYPE_MICROSOFT = 0x1;
static const Shortint CI_REGULAR = 0x1;
static const Shortint CI_ALTERNATE = 0x2;
static const Shortint CI_CURSOR = 0x3;
static const Shortint DB_IN = 0x1;
static const Shortint DB_OUT = 0x2;
static const Shortint BCPMAXERRS = 0x1;
static const Shortint BCPFIRST = 0x2;
static const Shortint BCPLAST = 0x3;
static const Shortint BCPBATCH = 0x4;
static const Shortint BCPKEEPNULLS = 0x5;
static const Shortint BCPABORT = 0x6;
static const Shortint TINYBIND = 0x1;
static const Shortint SMALLBIND = 0x2;
static const Shortint INTBIND = 0x3;
static const Shortint CHARBIND = 0x4;
static const Shortint BINARYBIND = 0x5;
static const Shortint BITBIND = 0x6;
static const Shortint DATETIMEBIND = 0x7;
static const Shortint MONEYBIND = 0x8;
static const Shortint FLT8BIND = 0x9;
static const Shortint STRINGBIND = 0xa;
static const Shortint NTBSTRINGBIND = 0xb;
static const Shortint VARYCHARBIND = 0xc;
static const Shortint VARYBINBIND = 0xd;
static const Shortint FLT4BIND = 0xe;
static const Shortint SMALLMONEYBIND = 0xf;
static const Shortint SMALLDATETIBIND = 0x10;
static const Shortint DECIMALBIND = 0x11;
static const Shortint NUMERICBIND = 0x12;
static const Shortint SRCDECIMALBIND = 0x13;
static const Shortint SRCNUMERICBIND = 0x14;
static const Shortint MAXBIND = 0x14;
static const Shortint DBSAVE = 0x1;
static const Shortint DBNOSAVE = 0x0;
static const Shortint DBNOERR = 0xffffffff;
static const Shortint DBFAIL = 0x0;
static const Shortint DBSUCCEED = 0x1;
static const Shortint DBFINDONE = 0x4;
static const Shortint DBMORE = 0x10;
static const Shortint DBMORE_ROWS = 0x20;
static const Shortint MAXNAME = 0x1f;
static const Shortint DBTXTSLEN = 0x8;
static const Shortint DBTXPLEN = 0x10;
static const Shortint INT_EXIT = 0x0;
static const Shortint INT_CONTINUE = 0x1;
static const Shortint INT_CANCEL = 0x2;
static const Shortint DBBUFFER = 0x0;
static const Shortint DBOFFSET = 0x1;
static const Shortint DBROWCOUNT = 0x2;
static const Shortint DBSTAT = 0x3;
static const Shortint DBTEXTLIMIT = 0x4;
static const Shortint DBTEXTSIZE = 0x5;
static const Shortint DBARITHABORT = 0x6;
static const Shortint DBARITHIGNORE = 0x7;
static const Shortint DBNOAUTOFREE = 0x8;
static const Shortint DBNOCOUNT = 0x9;
static const Shortint DBNOEXEC = 0xa;
static const Shortint DBPARSEONLY = 0xb;
static const Shortint DBSHOWPLAN = 0xc;
static const Shortint DBSTORPROCID = 0xd;
static const Shortint DBANSITOOEM = 0xe;
static const Shortint DBOEMTOANSI = 0xf;
static const Shortint DBCLIENTCURSORS = 0x10;
static const Shortint DBSET_TIME = 0x11;
static const Shortint DBQUOTEDIDENT = 0x12;
static const Shortint SQLVOID = 0x1f;
static const Shortint SQLTEXT = 0x23;
static const Shortint SQLVARBINARY = 0x25;
static const Shortint SQLINTN = 0x26;
static const Shortint SQLVARCHAR = 0x27;
static const Shortint SQLBINARY = 0x2d;
static const Shortint SQLIMAGE = 0x22;
static const Shortint SQLCHAR = 0x2f;
static const Shortint SQLINT1 = 0x30;
static const Shortint SQLBIT = 0x32;
static const Shortint SQLINT2 = 0x34;
static const Shortint SQLINT4 = 0x38;
static const Shortint SQLMONEY = 0x3c;
static const Shortint SQLDATETIME = 0x3d;
static const Shortint SQLFLT8 = 0x3e;
static const Shortint SQLFLTN = 0x6d;
static const Shortint SQLMONEYN = 0x6e;
static const Shortint SQLDATETIMN = 0x6f;
static const Shortint SQLFLT4 = 0x3b;
static const Shortint SQLMONEY4 = 0x7a;
static const Shortint SQLDATETIM4 = 0x3a;
static const Shortint SQLDECIMAL = 0x6a;
static const Shortint SQLNUMERIC = 0x6c;
static const Byte SQLCOLFMT = 0xa1;
static const Shortint OLD_SQLCOLFMT = 0x2a;
static const Shortint SQLPROCID = 0x7c;
static const Byte SQLCOLNAME = 0xa0;
static const Byte SQLTABNAME = 0xa4;
static const Byte SQLCOLINFO = 0xa5;
static const Byte SQLALTNAME = 0xa7;
static const Byte SQLALTFMT = 0xa8;
static const Byte SQLERROR = 0xaa;
static const Byte SQLINFO = 0xab;
static const Byte SQLRETURNVALUE = 0xac;
static const Shortint SQLRETURNSTATUS = 0x79;
static const Byte SQLRETURN = 0xdb;
static const Byte SQLCONTROL = 0xae;
static const Byte SQLALTCONTROL = 0xaf;
static const Byte SQLROW = 0xd1;
static const Byte SQLALTROW = 0xd3;
static const Byte SQLDONE = 0xfd;
static const Byte SQLDONEPROC = 0xfe;
static const Byte SQLDONEINPROC = 0xff;
static const Shortint SQLOFFSET = 0x78;
static const Byte SQLORDER = 0xa9;
static const Byte SQLLOGINACK = 0xad;
static const Shortint SQLAOPCNT = 0x4b;
static const Shortint SQLAOPSUM = 0x4d;
static const Shortint SQLAOPAVG = 0x4f;
static const Shortint SQLAOPMIN = 0x51;
static const Shortint SQLAOPMAX = 0x52;
static const Shortint SQLAOPANY = 0x53;
static const Shortint SQLAOPNOOP = 0x56;
static const Word SQLEMEM = 0x2710;
static const Word SQLENULL = 0x2711;
static const Word SQLENLOG = 0x2712;
static const Word SQLEPWD = 0x2713;
static const Word SQLECONN = 0x2714;
static const Word SQLEDDNE = 0x2715;
static const Word SQLENULLO = 0x2716;
static const Word SQLESMSG = 0x2717;
static const Word SQLEBTOK = 0x2718;
static const Word SQLENSPE = 0x2719;
static const Word SQLEREAD = 0x271a;
static const Word SQLECNOR = 0x271b;
static const Word SQLETSIT = 0x271c;
static const Word SQLEPARM = 0x271d;
static const Word SQLEAUTN = 0x271e;
static const Word SQLECOFL = 0x271f;
static const Word SQLERDCN = 0x2720;
static const Word SQLEICN = 0x2721;
static const Word SQLECLOS = 0x2722;
static const Word SQLENTXT = 0x2723;
static const Word SQLEDNTI = 0x2724;
static const Word SQLETMTD = 0x2725;
static const Word SQLEASEC = 0x2726;
static const Word SQLENTLL = 0x2727;
static const Word SQLETIME = 0x2728;
static const Word SQLEWRIT = 0x2729;
static const Word SQLEMODE = 0x272a;
static const Word SQLEOOB = 0x272b;
static const Word SQLEITIM = 0x272c;
static const Word SQLEDBPS = 0x272d;
static const Word SQLEIOPT = 0x272e;
static const Word SQLEASNL = 0x272f;
static const Word SQLEASUL = 0x2730;
static const Word SQLENPRM = 0x2731;
static const Word SQLEDBOP = 0x2732;
static const Word SQLENSIP = 0x2733;
static const Word SQLECNULL = 0x2734;
static const Word SQLESEOF = 0x2735;
static const Word SQLERPND = 0x2736;
static const Word SQLECSYN = 0x2737;
static const Word SQLENONET = 0x2738;
static const Word SQLEBTYP = 0x2739;
static const Word SQLEABNC = 0x273a;
static const Word SQLEABMT = 0x273b;
static const Word SQLEABNP = 0x273c;
static const Word SQLEBNCR = 0x273d;
static const Word SQLEAAMT = 0x273e;
static const Word SQLENXID = 0x273f;
static const Word SQLEIFNB = 0x2740;
static const Word SQLEKBCO = 0x2741;
static const Word SQLEBBCI = 0x2742;
static const Word SQLEKBCI = 0x2743;
static const Word SQLEBCWE = 0x2744;
static const Word SQLEBCNN = 0x2745;
static const Word SQLEBCOR = 0x2746;
static const Word SQLEBCPI = 0x2747;
static const Word SQLEBCPN = 0x2748;
static const Word SQLEBCPB = 0x2749;
static const Word SQLEVDPT = 0x274a;
static const Word SQLEBIVI = 0x274b;
static const Word SQLEBCBC = 0x274c;
static const Word SQLEBCFO = 0x274d;
static const Word SQLEBCVH = 0x274e;
static const Word SQLEBCUO = 0x274f;
static const Word SQLEBUOE = 0x2750;
static const Word SQLEBWEF = 0x2751;
static const Word SQLEBTMT = 0x2752;
static const Word SQLEBEOF = 0x2753;
static const Word SQLEBCSI = 0x2754;
static const Word SQLEPNUL = 0x2755;
static const Word SQLEBSKERR = 0x2756;
static const Word SQLEBDIO = 0x2757;
static const Word SQLEBCNT = 0x2758;
static const Word SQLEMDBP = 0x2759;
static const Word SQLINIT = 0x275a;
static const Word SQLCRSINV = 0x275b;
static const Word SQLCRSCMD = 0x275c;
static const Word SQLCRSNOIND = 0x275d;
static const Word SQLCRSDIS = 0x275e;
static const Word SQLCRSAGR = 0x275f;
static const Word SQLCRSORD = 0x2760;
static const Word SQLCRSMEM = 0x2761;
static const Word SQLCRSBSKEY = 0x2762;
static const Word SQLCRSNORES = 0x2763;
static const Word SQLCRSVIEW = 0x2764;
static const Word SQLCRSBUFR = 0x2765;
static const Word SQLCRSFROWN = 0x2766;
static const Word SQLCRSBROL = 0x2767;
static const Word SQLCRSFRAND = 0x2768;
static const Word SQLCRSFLAST = 0x2769;
static const Word SQLCRSRO = 0x276a;
static const Word SQLCRSTAB = 0x276b;
static const Word SQLCRSUPDTAB = 0x276c;
static const Word SQLCRSUPDNB = 0x276d;
static const Word SQLCRSVIIND = 0x276e;
static const Word SQLCRSNOUPD = 0x276f;
static const Word SQLCRSOS2 = 0x2770;
static const Word SQLEBCSA = 0x2771;
static const Word SQLEBCRO = 0x2772;
static const Word SQLEBCNE = 0x2773;
static const Word SQLEBCSK = 0x2774;
static const Word SQLEUVBF = 0x2775;
static const Word SQLEBIHC = 0x2776;
static const Word SQLEBWFF = 0x2777;
static const Word SQLNUMVAL = 0x2778;
static const Word SQLEOLDVR = 0x2779;
static const Word SQLEBCPS = 0x277a;
static const Word SQLEDTC = 0x277b;
static const Word SQLENOTIMPL = 0x277c;
static const Word SQLENONFLOAT = 0x277d;
static const Word SQLECONNFB = 0x277e;
static const Shortint EXINFO = 0x1;
static const Shortint EXUSER = 0x2;
static const Shortint EXNONFATAL = 0x3;
static const Shortint EXCONVERSION = 0x4;
static const Shortint EXSERVER = 0x5;
static const Shortint EXTIME = 0x6;
static const Shortint EXPROGRAM = 0x7;
static const Shortint EXRESOURCE = 0x8;
static const Shortint EXCOMM = 0x9;
static const Shortint EXFATAL = 0xa;
static const Shortint EXCONSISTENCY = 0xb;
static const Word OFF_SELECT = 0x16d;
static const Word OFF_FROM = 0x14f;
static const Word OFF_ORDER = 0x165;
static const Word OFF_COMPUTE = 0x139;
static const Word OFF_TABLE = 0x173;
static const Word OFF_PROCEDURE = 0x16a;
static const Word OFF_STATEMENT = 0x1cb;
static const Word OFF_PARAM = 0x1c4;
static const Word OFF_EXEC = 0x12c;
static const Shortint MAXNUMERICLEN = 0x10;
static const Shortint MAXNUMERICDIG = 0x26;
static const Shortint DEFAULTPRECISION = 0x12;
static const Shortint DEFAULTSCALE = 0x0;
static const Shortint PRINT4 = 0xb;
static const Shortint PRINT2 = 0x6;
static const Shortint PRINT1 = 0x3;
static const Shortint PRFLT8 = 0x14;
static const Shortint PRMONEY = 0x1a;
static const Shortint PRBIT = 0x3;
static const Shortint PRDATETIME = 0x1b;
static const Shortint PRDECIMAL = 0x28;
static const Shortint PRNUMERIC = 0x28;
static const Shortint SUCCEED = 0x1;
static const Shortint FAIL = 0x0;
static const Shortint SUCCEED_ABORT = 0x2;
static const Shortint DBUNKNOWN = 0x2;
static const Shortint MORE_ROWS = 0xffffffff;
static const Shortint NO_MORE_ROWS = 0xfffffffe;
static const Shortint REG_ROW = 0xffffffff;
static const Shortint BUF_FULL = 0xfffffffd;
static const Shortint NO_MORE_RESULTS = 0x2;
static const Shortint NO_MORE_RPC_RESULTS = 0x3;
static const Shortint DBSETHOST = 0x1;
static const Shortint DBSETUSER = 0x2;
static const Shortint DBSETPWD = 0x3;
static const Shortint DBSETAPP = 0x4;
static const Shortint DBSETID = 0x5;
static const Shortint DBSETLANG = 0x6;
static const Shortint DBSETSECURE = 0x7;
static const Shortint DBVER42 = 0x8;
static const Shortint DBVER60 = 0x9;
static const Shortint DBSET_LOGIN_TIME = 0xa;
static const Shortint DBSETFALLBACK = 0xc;
static const Shortint STDEXIT = 0x0;
static const Shortint ERREXIT = 0xffffffff;
static const Shortint DBRPCRECOMPILE = 0x1;
static const Shortint DBRPCRESET = 0x4;
static const Shortint DBRPCCURSOR = 0x8;
static const Shortint DBRPCRETURN = 0x1;
static const Shortint DBRPCDEFAULT = 0x2;
static const Shortint CUR_READONLY = 0x1;
static const Shortint CUR_LOCKCC = 0x2;
static const Shortint CUR_OPTCC = 0x3;
static const Shortint CUR_OPTCCVAL = 0x4;
static const Shortint CUR_FORWARD = 0x0;
static const Shortint CUR_KEYSET = 0xffffffff;
static const Shortint CUR_DYNAMIC = 0x1;
static const Shortint CUR_INSENSITIVE = 0xfffffffe;
static const Shortint FETCH_FIRST = 0x1;
static const Shortint FETCH_NEXT = 0x2;
static const Shortint FETCH_PREV = 0x3;
static const Shortint FETCH_RANDOM = 0x4;
static const Shortint FETCH_RELATIVE = 0x5;
static const Shortint FETCH_LAST = 0x6;
static const Shortint FTC_EMPTY = 0x0;
static const Shortint FTC_SUCCEED = 0x1;
static const Shortint FTC_MISSING = 0x2;
static const Shortint FTC_ENDOFKEYSET = 0x4;
static const Shortint FTC_ENDOFRESULTS = 0x8;
static const Shortint CRS_UPDATE = 0x1;
static const Shortint CRS_DELETE = 0x2;
static const Shortint CRS_INSERT = 0x3;
static const Shortint CRS_REFRESH = 0x4;
static const Shortint CRS_LOCKCC = 0x5;
static const Shortint NOBIND = 0xfffffffe;
static const Shortint CU_CLIENT = 0x1;
static const Shortint CU_SERVER = 0x2;
static const Shortint CU_KEYSET = 0x4;
static const Shortint CU_MIXED = 0x8;
static const Shortint CU_DYNAMIC = 0x10;
static const Shortint CU_FORWARD = 0x20;
static const Shortint CU_INSENSITIVE = 0x40;
static const Byte CU_READONLY = 0x80;
static const Word CU_LOCKCC = 0x100;
static const Word CU_OPTCC = 0x200;
static const Word CU_OPTCCVAL = 0x400;
static const Shortint CU_FILLING = 0x1;
static const Shortint CU_FILLED = 0x2;
static const Shortint UT_TEXTPTR = 0x1;
static const Shortint UT_TEXT = 0x2;
static const Shortint UT_MORETEXT = 0x4;
static const Shortint UT_DELETEONLY = 0x8;
static const Shortint UT_LOG = 0x10;
static const Shortint NET_SEARCH = 0x1;
static const Shortint LOC_SEARCH = 0x2;
static const Shortint ENUM_SUCCESS = 0x0;
static const Shortint MORE_DATA = 0x1;
static const Shortint NET_NOT_AVAIL = 0x2;
static const Shortint OUT_OF_MEMORY = 0x4;
static const Shortint NOT_SUPPORTED = 0x8;
static const Shortint ENUM_INVALID_PARAM = 0x10;
static const Shortint NE_E_NOMAP = 0x0;
static const Shortint NE_E_NOMEMORY = 0x1;
static const Shortint NE_E_NOACCESS = 0x2;
static const Shortint NE_E_CONNBUSY = 0x3;
static const Shortint NE_E_CONNBROKEN = 0x4;
static const Shortint NE_E_TOOMANYCONN = 0x5;
static const Shortint NE_E_SERVERNOTFOUND = 0x6;
static const Shortint NE_E_NETNOTSTARTED = 0x7;
static const Shortint NE_E_NORESOURCE = 0x8;
static const Shortint NE_E_NETBUSY = 0x9;
static const Shortint NE_E_NONETACCESS = 0xa;
static const Shortint NE_E_GENERAL = 0xb;
static const Shortint NE_E_CONNMODE = 0xc;
static const Shortint NE_E_NAMENOTFOUND = 0xd;
static const Shortint NE_E_INVALIDCONN = 0xe;
static const Shortint NE_E_NETDATAERR = 0xf;
static const Shortint NE_E_TOOMANYFILES = 0x10;
static const Shortint NE_E_CANTCONNECT = 0x11;
static const Shortint NE_MAX_NETERROR = 0x11;
static const Word DBMAXCHAR = 0x100;
static const Shortint MAXCOLNAMELEN = 0x1e;
static const Shortint MAXTABLENAME = 0x1e;
static const Shortint MAXSERVERNAME = 0x1e;
static const Byte MAXNETLIBNAME = 0xff;
static const Byte MAXNETLIBCONNSTR = 0xff;
static const unsigned INVALID_UROWNUM = 0xffffffff;
extern PACKAGE Tdberrhandle dberrhandle;
extern PACKAGE Tdbmsghandle dbmsghandle;
extern PACKAGE Tdbprocerrhandle dbprocerrhandle;
extern PACKAGE Tdbprocmsghandle dbprocmsghandle;
extern PACKAGE Tabort_xact abort_xact;
extern PACKAGE Tbuild_xact_string build_xact_string;
extern PACKAGE Tclose_commit close_commit;
extern PACKAGE Tcommit_xact commit_xact;
extern PACKAGE Topen_commit open_commit;
extern PACKAGE Tremove_xact remove_xact;
extern PACKAGE Tscan_xact scan_xact;
extern PACKAGE Tstart_xact start_xact;
extern PACKAGE Tstat_xact stat_xact;
extern PACKAGE Tbcp_batch bcp_batch;
extern PACKAGE Tbcp_bind bcp_bind;
extern PACKAGE Tbcp_colfmt bcp_colfmt;
extern PACKAGE Tbcp_collen bcp_collen;
extern PACKAGE Tbcp_colptr bcp_colptr;
extern PACKAGE Tbcp_columns bcp_columns;
extern PACKAGE Tbcp_control bcp_control;
extern PACKAGE Tbcp_done bcp_done;
extern PACKAGE Tbcp_exec bcp_exec;
extern PACKAGE Tbcp_init bcp_init;
extern PACKAGE Tbcp_moretext bcp_moretext;
extern PACKAGE Tbcp_readfmt bcp_readfmt;
extern PACKAGE Tbcp_sendrow bcp_sendrow;
extern PACKAGE Tbcp_setl bcp_setl;
extern PACKAGE Tbcp_writefmt bcp_writefmt;
extern PACKAGE Tdbadata dbadata;
extern PACKAGE Tdbadlen dbadlen;
extern PACKAGE Tdbaltbind dbaltbind;
extern PACKAGE Tdbaltcolid dbaltcolid;
extern PACKAGE Tdbaltlen dbaltlen;
extern PACKAGE Tdbaltop dbaltop;
extern PACKAGE Tdbalttype dbalttype;
extern PACKAGE Tdbaltutype dbaltutype;
extern PACKAGE Tdbanullbind dbanullbind;
extern PACKAGE Tdbbind dbbind;
extern PACKAGE Tdbbylist dbbylist;
extern PACKAGE Tdbcancel dbcancel;
extern PACKAGE Tdbcanquery dbcanquery;
extern PACKAGE Tdbchange dbchange;
extern PACKAGE Tdbclose dbclose;
extern PACKAGE Tdbclrbuf dbclrbuf;
extern PACKAGE Tdbclropt dbclropt;
extern PACKAGE Tdbcmd dbcmd;
extern PACKAGE Tdbcmdrow dbcmdrow;
extern PACKAGE Tdbcolbrowse dbcolbrowse;
extern PACKAGE Tdbcolinfo dbcolinfo;
extern PACKAGE Tdbcollen dbcollen;
extern PACKAGE Tdbcolname dbcolname;
extern PACKAGE Tdbcolsource dbcolsource;
extern PACKAGE Tdbcoltype dbcoltype;
extern PACKAGE Tdbcolutype dbcolutype;
extern PACKAGE Tdbconvert dbconvert;
extern PACKAGE Tdbcount dbcount;
extern PACKAGE Tdbcurcmd dbcurcmd;
extern PACKAGE Tdbcurrow dbcurrow;
extern PACKAGE Tdbcursor dbcursor;
extern PACKAGE Tdbcursorbind dbcursorbind;
extern PACKAGE Tdbcursorclose dbcursorclose;
extern PACKAGE Tdbcursorcolinfo dbcursorcolinfo;
extern PACKAGE Tdbcursorfetch dbcursorfetch;
extern PACKAGE Tdbcursorfetchex dbcursorfetchex;
extern PACKAGE Tdbcursorinfo dbcursorinfo;
extern PACKAGE Tdbcursorinfoex dbcursorinfoex;
extern PACKAGE Tdbcursoropen dbcursoropen;
extern PACKAGE Tdbdata dbdata;
extern PACKAGE Tdbdataready dbdataready;
extern PACKAGE Tdbdatecrack dbdatecrack;
extern PACKAGE Tdbdatlen dbdatlen;
extern PACKAGE Tdbdead dbdead;
extern PACKAGE Tdbexit dbexit;
extern PACKAGE Tdbfirstrow dbfirstrow;
extern PACKAGE Tdbfreebuf dbfreebuf;
extern PACKAGE Tdbfreelogin dbfreelogin;
extern PACKAGE Tdbfreequal dbfreequal;
extern PACKAGE Tdbgetchar dbgetchar;
extern PACKAGE Tdbgetmaxprocs dbgetmaxprocs;
extern PACKAGE Tdbgetoff dbgetoff;
extern PACKAGE Tdbgetpacket dbgetpacket;
extern PACKAGE Tdbgetrow dbgetrow;
extern PACKAGE Tdbgettime dbgettime;
extern PACKAGE Tdbgetuserdata dbgetuserdata;
extern PACKAGE Tdbhasretstat dbhasretstat;
extern PACKAGE Tdbinit dbinit;
extern PACKAGE Tdbisavail dbisavail;
extern PACKAGE Tdbiscount dbiscount;
extern PACKAGE Tdbisopt dbisopt;
extern PACKAGE Tdblastrow dblastrow;
extern PACKAGE Tdblogin dblogin;
extern PACKAGE Tdbmorecmds dbmorecmds;
extern PACKAGE Tdbmoretext dbmoretext;
extern PACKAGE Tdbname dbname;
extern PACKAGE Tdbnextrow dbnextrow;
extern PACKAGE Tdbnullbind dbnullbind;
extern PACKAGE Tdbnumalts dbnumalts;
extern PACKAGE Tdbnumcols dbnumcols;
extern PACKAGE Tdbnumcompute dbnumcompute;
extern PACKAGE Tdbnumorders dbnumorders;
extern PACKAGE Tdbnumrets dbnumrets;
extern PACKAGE Tdbopen dbopen;
extern PACKAGE Tdbordercol dbordercol;
extern PACKAGE Tdbprocinfo dbprocinfo;
extern PACKAGE Tdbprhead dbprhead;
extern PACKAGE Tdbprrow dbprrow;
extern PACKAGE Tdbprtype dbprtype;
extern PACKAGE Tdbqual dbqual;
extern PACKAGE Tdbreadtext dbreadtext;
extern PACKAGE Tdbresults dbresults;
extern PACKAGE Tdbretdata dbretdata;
extern PACKAGE Tdbretlen dbretlen;
extern PACKAGE Tdbretname dbretname;
extern PACKAGE Tdbretstatus dbretstatus;
extern PACKAGE Tdbrettype dbrettype;
extern PACKAGE Tdbrows dbrows;
extern PACKAGE Tdbrowtype dbrowtype;
extern PACKAGE Tdbrpcinit dbrpcinit;
extern PACKAGE Tdbrpcparam dbrpcparam;
extern PACKAGE Tdbrpcsend dbrpcsend;
extern PACKAGE Tdbrpcexec dbrpcexec;
extern PACKAGE Tdbrpwclr dbrpwclr;
extern PACKAGE Tdbserverenum dbserverenum;
extern PACKAGE Tdbsetavail dbsetavail;
extern PACKAGE Tdbsetmaxprocs dbsetmaxprocs;
extern PACKAGE Tdbsetlname dbsetlname;
extern PACKAGE Tdbsetlogintime dbsetlogintime;
extern PACKAGE Tdbsetlpacket dbsetlpacket;
extern PACKAGE Tdbsetnull dbsetnull;
extern PACKAGE Tdbsetopt dbsetopt;
extern PACKAGE Tdbsettime dbsettime;
extern PACKAGE Tdbsetuserdata dbsetuserdata;
extern PACKAGE Tdbsqlexec dbsqlexec;
extern PACKAGE Tdbsqlok dbsqlok;
extern PACKAGE Tdbsqlsend dbsqlsend;
extern PACKAGE Tdbstrcpy dbstrcpy;
extern PACKAGE Tdbstrlen dbstrlen;
extern PACKAGE Tdbtabbrowse dbtabbrowse;
extern PACKAGE Tdbtabcount dbtabcount;
extern PACKAGE Tdbtabname dbtabname;
extern PACKAGE Tdbtabsource dbtabsource;
extern PACKAGE Tdbtsnewlen dbtsnewlen;
extern PACKAGE Tdbtsnewval dbtsnewval;
extern PACKAGE Tdbtsput dbtsput;
extern PACKAGE Tdbtxptr dbtxptr;
extern PACKAGE Tdbtxtimestamp dbtxtimestamp;
extern PACKAGE Tdbtxtsnewval dbtxtsnewval;
extern PACKAGE Tdbtxtsput dbtxtsput;
extern PACKAGE Tdbuse dbuse;
extern PACKAGE Tdbvarylen dbvarylen;
extern PACKAGE Tdbwillconvert dbwillconvert;
extern PACKAGE Tdbwritetext dbwritetext;
extern PACKAGE Tdbupdatetext dbupdatetext;
extern PACKAGE AnsiString DLL;
extern PACKAGE unsigned hDLL;
extern PACKAGE bool LibLoaded;
extern PACKAGE AnsiString __fastcall dbsqlerror();
extern PACKAGE AnsiString __fastcall dboserror();
extern PACKAGE AnsiString __fastcall dbmessage();
extern PACKAGE bool __fastcall MsSqlLoadLib(void);
extern PACKAGE int __fastcall DBSETLHOST(void * Login, char * ClientHost);
extern PACKAGE int __fastcall DBSETLUSER(void * Login, char * UserName);
extern PACKAGE int __fastcall DBSETLPWD(void * Login, char * Passwd);
extern PACKAGE int __fastcall DBSETLAPP(void * Login, char * AppName);
extern PACKAGE int __fastcall DBSETLNATLANG(void * Login, char * Lang);
extern PACKAGE int __fastcall DBSETLSECURE(void * Login);
extern PACKAGE int __fastcall DBSETLVERSION(void * Login, Byte Version);
extern PACKAGE int __fastcall DBSETLTIME(void * Login, unsigned Seconds);
extern PACKAGE int __fastcall DBSETLFALLBACK(void * Login, char * Fallback);
extern PACKAGE int __fastcall dbrbuf(void * Proc);

}	/* namespace Zlibmssql */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Zlibmssql;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZLibMsSql
